%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%2345678901234567890123456789012345678901234567890123456789012345678901234567890
%        1         2         3         4         5         6         7         8
\UseRawInputEncoding
\documentclass[letterpaper, 10 pt, conference]{ieeeconf}  % Comment this line out if you need a4paper

%\documentclass[a4paper, 10pt, conference]{ieeeconf}      % Use this line for a4 paper

\IEEEoverridecommandlockouts                              % This command is only needed if 
                                                          % you want to use the \thanks command

\overrideIEEEmargins                                      % Needed to meet printer requirements.

%In case you encounter the following error:
%Error 1010 The PDF file may be corrupt (unable to open PDF file) OR
%Error 1000 An error occurred while parsing a contents stream. Unable to analyze the PDF file.
%This is a known problem with pdfLaTeX conversion filter. The file cannot be opened with acrobat reader
%Please use one of the alternatives below to circumvent this error by uncommenting one or the other
%\pdfobjcompresslevel=0
%\pdfminorversion=4

% See the \addtolength command later in the file to balance the column lengths
% on the last page of the document

% The following packages can be found on http:\\www.ctan.org
%\usepackage{graphics} % for pdf, bitmapped graphics files
%\usepackage{epsfig} % for postscript graphics files
%\usepackage{mathptmx} % assumes new font selection scheme installed
%\usepackage{times} % assumes new font selection scheme installed
%\usepackage{amsmath} % assumes amsmath package installed
%\usepackage{amssymb}  % assumes amsmath package installed
\usepackage{graphicx}

\title{\LARGE \bf
Report on Reinforcement Learning
}


\author{Yuanzheng Fang, Zhenxin Zhang and Yiming Liu% <-this % stops a space
%\thanks{*This work was not supported by any organization}% <-this % stops a space
%\thanks{$^{1}$Albert Author is with Faculty of Electrical Engineering, Mathematics and Computer Science,
%        University of Twente, 7500 AE Enschede, The Netherlands
%        {\tt\small albert.author@papercept.net}}%
%\thanks{$^{2}$Bernard D. Researcheris with the Department of Electrical Engineering, Wright State University,
%        Dayton, OH 45435, USA
%        {\tt\small b.d.researcher@ieee.org}}%
}


\begin{document}



\maketitle
\thispagestyle{empty}
\pagestyle{empty}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{abstract}

This is the report on the final project of our group. We tried model-based reinforcement learning,  model-free reinforcement learning and optimal control on three models, namely spring-mass-damper model, inverted pendulum model and cart-pole model. Comparison and discussion about these three algorithms are also given in this document.

\end{abstract}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{INTRODUCTION}

This template provides authors with most of the formatting specifications needed for preparing electronic versions of their papers. All standard paper components have been specified for three reasons: (1) ease of use when formatting individual papers, (2) automatic compliance to electronic requirements that facilitate the concurrent or later production of electronic products, and (3) conformity of style throughout a conference proceedings. Margins, column widths, line spacing, and type styles are built-in; examples of the type styles are provided throughout this document and are identified in italic type, within parentheses, following the example. Some components, such as multi-leveled equations, graphics, and tables are not prescribed, although the various table text styles are provided. The formatter will need to create these components, incorporating the applicable criteria that follow.

\section{PROCEDURE FOR PAPER SUBMISSION}

\subsection{Selecting a Template (Heading 2)}

First, confirm that you have the correct template for your paper size. This template has been tailored for output on the US-letter paper size. 
It may be used for A4 paper size if the paper size setting is suitably modified.

\subsection{Maintaining the Integrity of the Specifications}

The template is used to format your paper and style the text. All margins, column widths, line spaces, and text fonts are prescribed; please do not alter them. You may note peculiarities. For example, the head margin in this template measures proportionately more than is customary. This measurement and others are deliberate, using specifications that anticipate your paper as one part of the entire proceedings, and not as an independent document. Please do not revise any of the current designations

\section{PILCO}

In order to approximate the dynamics of the system and minimize the cumulative cost, the PILCO algorithm uses the Gaussian Process and non-convex policy optimization. 

\subsection{PILCO algorithm}
The following is the details of the algorithm.
1. 	PILCO's probabilistic dynamics model is implemented as a GP, with input training data $\widetilde{x_{t}}$and output data $\Delta_{t}$. 
$$
p(x_{t}|x_{t-1},u_{t-1} )=\mathcal N(x_{t}|\mu_{t},\Sigma_{t} )
$$
$$
\Delta_{t}= x_{t}- x_{t-1}+ \varepsilon
$$
$$
\mu_{t}= x_{t-1}+ E_{f}[\Delta_{t}]
$$
$$
\widetilde{x_{t}} = (x_{t},u_{t})
$$

$\widetilde{x_{t}}$, $\Delta_{t}$, $\varepsilon$ all satisfy gaussian distribution.
2. By calculating the following function, PILCO can calculate the value function of the current policy with probabilistic dynamical model.
$$
V_{pi}(x_0)= \sum_{t=0}^{T}\int[c(x_t)p(x_t)dx_t]
$$
$c(x_t) $is the cost function that is defined by ourselves.
3.	At last, PILCO uses non-convex gradient-based policy search method to optimize the policy.
\subsection{Results}
1. Mass-Spring-Damper
\begin{figure}[thpb]
	\centering
	\framebox{\parbox{3in}{\includegraphics[width=7.6cm]{msd.jpg}
	}}
	%\includegraphics[scale=1.0]{figurefile}
	\caption{Result of PILCO Used on Mass-Spring-Damper Model}
	\label{figurelabel}
\end{figure}
In this figure, PILCO shows a good control effect for this model. The controlled state will finally approaches the target state with very small error.

2. Pendulum
\begin{figure}[thpb]
	\centering
	\framebox{\parbox{3in}{\includegraphics[width=7.6cm]{pendulum.jpg}
	}}
	%\includegraphics[scale=1.0]{figurefile}
	\caption{Result of PILCO Used on Pendulum Model}
	\label{figurelabel}
\end{figure}
This figure shows the best control effect of PILCO among these three models. Within a short duration, we can get a perfect policy almost without error.

3. Cartpole
1)$\theta_0 = 10^{\circ}$
\begin{figure}[thpb]
	\centering
	\framebox{\parbox{3in}{\includegraphics[width=7.6cm]{10.jpg}
	}}
	%\includegraphics[scale=1.0]{figurefile}
	\caption{Result of PILCO Used on Cart-Pole Model (Initial Angle=$10^{\circ}$).}
	\label{figurelabel}
\end{figure}
2)$\theta_0 = 90^{\circ}$
\begin{figure}[thpb]
	\centering
	\framebox{\parbox{3in}{\includegraphics[width=7.6cm]{90.jpg}
	}}
	%\includegraphics[scale=1.0]{figurefile}
	\caption{Result of PILCO Used on Cart-Pole Model (Initial Angle=$90^{\circ}$).}
	\label{figurelabel}
\end{figure}
3)$\theta_0 = 180^{\circ}$
\begin{figure}[thpb]
	\centering
	\framebox{\parbox{3in}{\includegraphics[width=7.6cm]{180.jpg}
	}}
	%\includegraphics[scale=1.0]{figurefile}
	\caption{Result of PILCO Used on Cart-Pole Model (Initial Angle=$180^{\circ}$).}
	\label{figurelabel}
\end{figure}
In this model, I trained the policy with initial angle $180^{\circ}$, and then apply the policy to other 2 initial angles. 
In above 3 figures,we can see that with initial angles $0^{\circ}$ and $90^{\circ}$, PILCO algorithm can get the target with small error as well, which also shows a good control effect, although the results are not so good as that of $180^{\circ}$. Generally, the policy we get can be applied with any initial angle, which is also an advantage of PILCO algorithm.

\section{Model Free}
In Model Free Reinforment Learning Algorithm, it's not necessary to build a model of the enviroment, the agent can learn a policy directly. In this part, I used Q-learning algorithm to train the three dynamic models. 
\subsection{Q-Learning Algorithm}
The goal of Q-learning is to learn a policy, which tells an agent what action to take under what circumstances. It finds a policy that is optimal in the sense that maximizes the expected value of the total reward over any and all successive steps, starting from the current state. The algorithm is as follows.
\begin{itemize}
	\item Generate state list $S$ and action list $A$.
	\item Set reward function $r$ and initialize the reward list $R$
	\item Initialize Q-table $Q$ with reward list 
	\item \textbf{For} each episode $k$ to maximum episode $E_p$ \textbf{do}
    
    \quad$s\leftarrow s_0$
    
    \quad \textbf{for} each iteration $i$ to max iteration step $I$
    
    \qquad \textbf{while} terminal state $s_t$ is not reached
    
    \qquad\quad select a state: $s\leftarrow\mathop{\arg\min}_{s'\in S}(s-s')^2$
   
    \qquad\quad select policy with greedy rule: \\
    $\pi(s)\leftarrow \mathop{\arg\max}_{a\inA}Q(s,a)$
    
    \qquad\quad select action $a$ with $\pi$, $s$
    
    \qquad\quad update the $Q-Table$: \\
    $Q(s,a)\leftarrow Q(s,a)+\alpha[r+\gamma*maxQ(s',a')-Q(s,a)]$
    
    \qquad\quad update current state: $s\leftarrow s'$
    
    \qquad end iteration
    
    \quad end episode
    
    return $Q$-Table
    
\end{itemize}


\subsection{Results}
\subsubsection{Mass-Spring-Damper}
  \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{\includegraphics[width=7.6cm]{q_mass_result.jpg}
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Result of Q-Learning Used on Spring-Mass-Damper Model}
      \label{figurelabel}
   \end{figure}
In the first task I selected 6 force from -1$N/m$ to 2$N/m$ as action set, and the state is a 2-$dimensional$ variable composed of the displacement $x$ and velocity $\dot{x}$. The reward function is defined by squared error between the real state and the target state $r=-100-10*(x-1.5)^2-5*(\dot{x}^2)$. I initialize the $Q$-Table with the initial $R$-Table rather than 0, because in this way the model will be trained faster. In each episode, during the iterations, if the state is very close to the target state, I give the reward a large positive bonus, finish this iteration and continue to next episode. Finally the training time is about 1.5 minute, and the error of displacement is about 0.05$m$, the error of velocity is about 0.2$m/s$ but as the $Fig. 6.$ shows, although it can reach nearby the target state, the velocity has a vibration at 0.

\subsubsection{Inverted Pendulum}
  \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{\includegraphics[width=7.6cm]{q_pendulum_result.jpg}
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Result of Q-learning Used on Inverted Pendulum Model}
      \label{figurelabel}
   \end{figure}
In the second task of Inverted Pendulum I used similiar method as before, after about 5 episodes the model will convergence to the target state faster, take only several hundrad iterarions. Traing time is about 3 mininute, the error of angle is $0.001^{\circ}$, the error of angle velocity is 0.001$rad/s$. For this model there is no obvious vibration.



\subsubsection{Cart Pole}
  \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{\includegraphics[width=7.6cm]{q_cart_lv.jpg}
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Result of Q-Learning Used on Cart-Pole Model}
      \label{figurelabel}
   \end{figure}
\begin{figure}[thpb]
	\centering
	\framebox{\parbox{3in}{\includegraphics[width=7.6cm]{q_cart_av.jpg}
	}}
	%\includegraphics[scale=1.0]{figurefile}
	\caption{Result of Q-Learning Used on Cart-Pole Model}
	\label{figurelabel}
\end{figure}

In the third task of cart pole model, I have tried the method as before for a lot of times, but they are all failed. The pendulum always rotate during training. Maybe it's because the high dimensional state, on the one hand it will cause a larger state list, but not all states in the list is availabe, one the other hand it will generate a very large $Q-Table$, it will be difficault to update all $q$ in the $Q-Table$ in limited episodes. The anathor reason may be the method of initializing $Q-Table$ with $R-Table$, the large number of unpractical states cause wrong $R-Table$ and is difficult to update them to expected value. So finally I simiplify the interval of generating the state list, to decrease the size of state list and $Q-Table$, and it works.

\quad As $Fig. 8.$ shows, after tens of episodes we can get expected results, the displacement $x$ stays in the interval$[-2.5,2.5]$, velocity $\dot{x}$ and angle velocity $\dot{\theta}$ will be nearby $0$. The angle $\theta$ is sometimes $0^{circ}$ and sometimes $2\pi$ because we select the upper vertical as $0^{circ}$. For the selection of initial angle of pendulum, I have tried $10^{\circ}$, $45^{\circ}$, $60^{\circ}$, $90^{\circ}$, $180^{\circ}$. The algorithm will perform good when the difference between the initial angle and upper vertical is less than $45^{\circ}$. As the figure shows, it will have a vibration.



\section{Optimal Control}

In optimal control, it is required to know the model of the optimization problem before hand. The goal is to reach the control task with the minimal energy. For example, we look for $u(t) \in \mathcal{U}$ with $t \in \left[t_o, t_f  \right]$ that minimizes the loss function
$$
J=  \Psi ( x_{t_f})+\int_{t_0}^{t_f} L(x( t), u(t),t)\, dt
$$
under the constraint
$$
\dot{x}( t)= f(x( t), u(t),t) 
$$
$$
x( t_0)=x_0
$$
In this section we tried two optimal control algorithms, i.e. LQR (Linear Quadratic Regulator) and iLQR (iterative Linear Quadratic Regulator).

\subsection{LQR Algotithm} For LQR, the dynamics of the system need to be described linearly, and the loss function is quadratic.
$$
J=  \frac{1}{2} x^{T} ( t_f) H x( t_f)+\int_{t_0}^{t_f} \left[ \frac{1}{2}x^T( t)Q( t) x( t)+\frac{1}{2}u^T( t)R( t) u( t)\right]\, dt
$$
under the constraint
$$
\dot{x}( t)= Ax(t)+Bu(t)
$$
$$
x( t_0)=x_0
$$
Using Variational Calculus or Dynamic Programming it is possible to show that the solution is:
$$
u^*(t)=-R^{-1}(t)B^T(t)K(t)x(t)
$$
where $K(t)$ is the solution of the Riccati equation:
$$
\dot{K}(t)=-K(t)A(t)-A^T(t)K(t)-Q(t)+K(t)B(t)R^{-1}(t)B^TK(t)
$$
$$
K(t_f)=H
$$

\subsection{LQR Results} We used LQR on the three models, it achieved a good result even though the idea behind this algorithm is quite easy. 

  \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{\includegraphics[width=7.6cm]{lqr_smd.png}
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Result of LQR Used on Spring-Mass-Damper Model}
      \label{figurelabel}
   \end{figure}
In the first task of the Spring-Mass-Damper Model, we can see that the controller works pretty well, since this model is a linear model, and the task is rather simple. However, we can see that the final position is not exactly 1.5, in fact it is a little bit smaller. This is because the LQR also tries to minimize the control energy. 

 \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{\includegraphics[width=7.6cm]{lqr_pendulum.png}
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Result of LQR Used on Inverted Pendulum Model}
      \label{figurelabel}
   \end{figure}
In the second task of the Inverted Pendulum Model, LQR can also reach the goal. But from the right figure, we can see that the velocity curve is oscillating, maybe this is because that the model itself is nonlinear, so we introduced some error to the model when trying to linearize it.

 \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{\includegraphics[width=7.6cm]{lqr_cart_pole.png}
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Result of LQR Used on Cart-Pole Model (Initial Angle=$10^{\circ}$).}
      \label{figurelabel}
   \end{figure}
In the third task of the Cart-Pole Model, the dynamics of the system is much more complex. I linearized the model in the region where the angle of the pole is near to $180^{\circ}$, however this leads to the problem that the model is very inaccurate when the pole starts from $90^{\circ}$ or $0^{\circ}$. After several trials, I find the algorithm works when the initial angle is between $180^{\circ}-65^{\circ}$ and $180^{\circ}+65^{\circ}$. If the initial angle is beyond this range, the algorithm fails to work.

\subsection{iLQR Algorithm}
The iLQR algorithm, as the name suggests, applies LQR to locally linear quadratic problems iteratively. ILQR is a variant of DDP, however, we remove the second order derivative of the dynamics.
$$
Q_x=l_x+{f_x}^T{V_x}'
$$
$$
Q_u=l_u+{f_u}^T{V_u}'
$$
$$
Q_{xx}=l_{xx}+{f_x}^T{V_{xx}}'f_x 
$$
$$
Q_{ux}=l_{ux}+{f_u}^T{V_{xx}}'f_x 
$$
$$
Q_{uu}=l_{uu}+{f_u}^T{V_{xx}}'f_u
$$

The iteration runs through a backward pass and a forward pass.
Backward pass:
\begin{itemize}
\item Initialize with terminal cost $V'(x_N)=l_f(x_N)$
\item Set the derivative of the cost function to zero by $\delta u \to \delta u = -{Q_{uu}}^{-1}(Q_{ux}\delta x+Q_u)$
\item Update $\delta u$ and go to the time step before.
\end{itemize}

Foreward pass:
\begin{itemize}
\item Apply the updated control value u and calculate the new states
\end{itemize}

Repeat Backward-Forward pass until convergence, e.g. max $\delta u < \epsilon$

\subsection{iLQR Results}
 \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{\includegraphics[width=7.6cm]{ilqr_smd.png}
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Result of iLQR Used on Spring-Mass-Damper Model}
      \label{figurelabel}
   \end{figure}

 \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{\includegraphics[width=7.6cm]{ilqr_pendulum.png}
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Result of iLQR Used on Inverted-Pendulum Model}
      \label{figurelabel}
   \end{figure}

Compared to the result of LQR, we can see that the convergence speed was similar. However, the speed is smoother in iLQR. This is probably because the iLQR is linearizing the model more accurately.



\section{USING THE TEMPLATE}

Use this sample document as your LaTeX source file to create your document. Save this file as {\bf root.tex}. You have to make sure to use the cls file that came with this distribution. If you use a different style file, you cannot expect to get required margins. Note also that when you are creating your out PDF file, the source file is only part of the equation. {\it Your \TeX\ $\rightarrow$ PDF filter determines the output file size. Even if you make all the specifications to output a letter file in the source - if your filter is set to produce A4, you will only get A4 output. }

It is impossible to account for all possible situation, one would encounter using \TeX. If you are using multiple \TeX\ files you must make sure that the ``MAIN`` source file is called root.tex - this is particularly important if your conference is using PaperPlaza's built in \TeX\ to PDF conversion tool.

\subsection{Headings, etc}

Text heads organize the topics on a relational, hierarchical basis. For example, the paper title is the primary text head because all subsequent material relates and elaborates on this one topic. If there are two or more sub-topics, the next level head (uppercase Roman numerals) should be used and, conversely, if there are not at least two sub-topics, then no subheads should be introduced. Styles named ÒHeading 1Ó, ÒHeading 2Ó, ÒHeading 3Ó, and ÒHeading 4Ó are prescribed.

\subsection{Figures and Tables}

Positioning Figures and Tables: Place figures and tables at the top and bottom of columns. Avoid placing them in the middle of columns. Large figures and tables may span across both columns. Figure captions should be below the figures; table heads should appear above the tables. Insert figures and tables after they are cited in the text. Use the abbreviation ÒFig. 1Ó, even at the beginning of a sentence.

\begin{table}[h]
\caption{An Example of a Table}
\label{table_example}
\begin{center}
\begin{tabular}{|c||c|}
\hline
One & Two\\
\hline
Three & Four\\
\hline
\end{tabular}
\end{center}
\end{table}


   \begin{figure}[thpb]
      \centering
      \framebox{\parbox{3in}{We suggest that you use a text box to insert a graphic (which is ideally a 300 dpi TIFF or EPS file, with all fonts embedded) because, in an document, this method is somewhat more stable than directly inserting a picture.
}}
      %\includegraphics[scale=1.0]{figurefile}
      \caption{Inductance of oscillation winding on amorphous
       magnetic core versus DC bias magnetic field}
      \label{figurelabel}
   \end{figure}
   

Figure Labels: Use 8 point Times New Roman for Figure labels. Use words rather than symbols or abbreviations when writing Figure axis labels to avoid confusing the reader. As an example, write the quantity ÒMagnetizationÓ, or ÒMagnetization, MÓ, not just ÒMÓ. If including units in the label, present them within parentheses. Do not label axes only with units. In the example, write ÒMagnetization (A/m)Ó or ÒMagnetization {A[m(1)]}Ó, not just ÒA/mÓ. Do not label axes with a ratio of quantities and units. For example, write ÒTemperature (K)Ó, not ÒTemperature/K.Ó

\section{CONCLUSIONS}

A conclusion section is not required. Although a conclusion may review the main points of the paper, do not replicate the abstract as the conclusion. A conclusion might elaborate on the importance of the work or suggest applications and extensions. 

\addtolength{\textheight}{-12cm}   % This command serves to balance the column lengths
                                  % on the last page of the document manually. It shortens
                                  % the textheight of the last page by a suitable amount.
                                  % This command does not take effect until the next page
                                  % so it should come on the page before the last. Make
                                  % sure that you do not shorten the textheight too much.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section*{APPENDIX}

Appendixes should appear before the acknowledgment.

\section*{ACKNOWLEDGMENT}

The preferred spelling of the word ÒacknowledgmentÓ in America is without an ÒeÓ after the ÒgÓ. Avoid the stilted expression, ÒOne of us (R. B. G.) thanks . . .Ó  Instead, try ÒR. B. G. thanksÓ. Put sponsor acknowledgments in the unnumbered footnote on the first page.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

References are important to the reader; therefore, each citation must be complete and correct. If at all possible, references should be commonly available publications.



\begin{thebibliography}{99}

\bibitem{c1} G. O. Young, ÒSynthetic structure of industrial plastics (Book style with paper title and editor),Ó 	in Plastics, 2nd ed. vol. 3, J. Peters, Ed.  New York: McGraw-Hill, 1964, pp. 15Ð64.
\bibitem{c2} W.-K. Chen, Linear Networks and Systems (Book style).	Belmont, CA: Wadsworth, 1993, pp. 123Ð135.
\bibitem{c3} H. Poor, An Introduction to Signal Detection and Estimation.   New York: Springer-Verlag, 1985, ch. 4.
\bibitem{c4} B. Smith, ÒAn approach to graphs of linear forms (Unpublished work style),Ó unpublished.
\bibitem{c5} E. H. Miller, ÒA note on reflector arrays (Periodical styleÑAccepted for publication),Ó IEEE Trans. Antennas Propagat., to be publised.
\bibitem{c6} J. Wang, ÒFundamentals of erbium-doped fiber amplifiers arrays (Periodical styleÑSubmitted for publication),Ó IEEE J. Quantum Electron., submitted for publication.
\bibitem{c7} C. J. Kaufman, Rocky Mountain Research Lab., Boulder, CO, private communication, May 1995.
\bibitem{c8} Y. Yorozu, M. Hirano, K. Oka, and Y. Tagawa, ÒElectron spectroscopy studies on magneto-optical media and plastic substrate interfaces(Translation Journals style),Ó IEEE Transl. J. Magn.Jpn., vol. 2, Aug. 1987, pp. 740Ð741 [Dig. 9th Annu. Conf. Magnetics Japan, 1982, p. 301].
\bibitem{c9} M. Young, The Techincal Writers Handbook.  Mill Valley, CA: University Science, 1989.
\bibitem{c10} J. U. Duncombe, ÒInfrared navigationÑPart I: An assessment of feasibility (Periodical style),Ó IEEE Trans. Electron Devices, vol. ED-11, pp. 34Ð39, Jan. 1959.
\bibitem{c11} S. Chen, B. Mulgrew, and P. M. Grant, ÒA clustering technique for digital communications channel equalization using radial basis function networks,Ó IEEE Trans. Neural Networks, vol. 4, pp. 570Ð578, July 1993.
\bibitem{c12} R. W. Lucky, ÒAutomatic equalization for digital communication,Ó Bell Syst. Tech. J., vol. 44, no. 4, pp. 547Ð588, Apr. 1965.
\bibitem{c13} S. P. Bingulac, ÒOn the compatibility of adaptive controllers (Published Conference Proceedings style),Ó in Proc. 4th Annu. Allerton Conf. Circuits and Systems Theory, New York, 1994, pp. 8Ð16.
\bibitem{c14} G. R. Faulhaber, ÒDesign of service systems with priority reservation,Ó in Conf. Rec. 1995 IEEE Int. Conf. Communications, pp. 3Ð8.
\bibitem{c15} W. D. Doyle, ÒMagnetization reversal in films with biaxial anisotropy,Ó in 1987 Proc. INTERMAG Conf., pp. 2.2-1Ð2.2-6.
\bibitem{c16} G. W. Juette and L. E. Zeffanella, ÒRadio noise currents n short sections on bundle conductors (Presented Conference Paper style),Ó presented at the IEEE Summer power Meeting, Dallas, TX, June 22Ð27, 1990, Paper 90 SM 690-0 PWRS.
\bibitem{c17} J. G. Kreifeldt, ÒAn analysis of surface-detected EMG as an amplitude-modulated noise,Ó presented at the 1989 Int. Conf. Medicine and Biological Engineering, Chicago, IL.
\bibitem{c18} J. Williams, ÒNarrow-band analyzer (Thesis or Dissertation style),Ó Ph.D. dissertation, Dept. Elect. Eng., Harvard Univ., Cambridge, MA, 1993. 
\bibitem{c19} N. Kawasaki, ÒParametric study of thermal and chemical nonequilibrium nozzle flow,Ó M.S. thesis, Dept. Electron. Eng., Osaka Univ., Osaka, Japan, 1993.
\bibitem{c20} J. P. Wilkinson, ÒNonlinear resonant circuit devices (Patent style),Ó U.S. Patent 3 624 12, July 16, 1990. 






\end{thebibliography}




\end{document}
